# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # Represents health evaluation for a partition, containing information
    # about the data and the algorithm used by health store to evaluate health.
    # The evaluation is returned only when the aggregated health state is
    # either Error or Warning.
    #
    class PartitionHealthEvaluation < HealthEvaluation

      include MsRestAzure


      def initialize
        @Kind = "Partition"
      end

      attr_accessor :Kind

      # @return Id of the partition whose health evaluation is described by
      # this object.
      attr_accessor :partition_id

      # @return [Array<HealthEvaluationWrapper>] List of unhealthy evaluations
      # that led to the current aggregated health state of the partition. The
      # types of the unhealthy evaluations can be ReplicasHealthEvaluation or
      # EventHealthEvaluation.
      attr_accessor :unhealthy_evaluations


      #
      # Mapper for PartitionHealthEvaluation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Partition',
          type: {
            name: 'Composite',
            class_name: 'PartitionHealthEvaluation',
            model_properties: {
              aggregated_health_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'AggregatedHealthState',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Description',
                type: {
                  name: 'String'
                }
              },
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              partition_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PartitionId',
                type: {
                  name: 'String'
                }
              },
              unhealthy_evaluations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UnhealthyEvaluations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'HealthEvaluationWrapperElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'HealthEvaluationWrapper'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
