# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Represents a scaling policy related to an average load of a
    # metric/resource of a service.
    #
    class AverageServiceLoadScalingTrigger < ScalingTriggerDescription

      include MsRestAzure


      def initialize
        @Kind = "AverageServiceLoad"
      end

      attr_accessor :Kind

      # @return [String] The name of the metric for which usage should be
      # tracked.
      attr_accessor :metric_name

      # @return [String] The lower limit of the load below which a scale in
      # operation should be performed.
      attr_accessor :lower_load_threshold

      # @return [String] The upper limit of the load beyond which a scale out
      # operation should be performed.
      attr_accessor :upper_load_threshold

      # @return [Integer] The period in seconds on which a decision is made
      # whether to scale or not.
      attr_accessor :scale_interval_in_seconds


      #
      # Mapper for AverageServiceLoadScalingTrigger class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AverageServiceLoad',
          type: {
            name: 'Composite',
            class_name: 'AverageServiceLoadScalingTrigger',
            model_properties: {
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              metric_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'MetricName',
                type: {
                  name: 'String'
                }
              },
              lower_load_threshold: {
                client_side_validation: true,
                required: true,
                serialized_name: 'LowerLoadThreshold',
                type: {
                  name: 'String'
                }
              },
              upper_load_threshold: {
                client_side_validation: true,
                required: true,
                serialized_name: 'UpperLoadThreshold',
                type: {
                  name: 'String'
                }
              },
              scale_interval_in_seconds: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ScaleIntervalInSeconds',
                constraints: {
                  InclusiveMaximum: 4294967295,
                  InclusiveMinimum: 0
                },
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
