# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Describes a container and its runtime properties.
    #
    class ContainerCodePackageProperties

      include MsRestAzure

      # @return [String] The name of the code package.
      attr_accessor :name

      # @return [String] The Container image to use.
      attr_accessor :image

      # @return [ImageRegistryCredential] Image registry credential.
      attr_accessor :image_registry_credential

      # @return [String] Override for the default entry point in the container.
      attr_accessor :entrypoint

      # @return [Array<String>] Command array to execute within the container
      # in exec form.
      attr_accessor :commands

      # @return [Array<EnvironmentVariable>] The environment variables to set
      # in this container
      attr_accessor :environment_variables

      # @return [Array<Setting>] The settings to set in this container. The
      # setting file path can be fetched from environment variable
      # "Fabric_SettingPath". The path for Windows container is "C:\\secrets".
      # The path for Linux container is "/var/secrets".
      attr_accessor :settings

      # @return [Array<ContainerLabel>] The labels to set in this container.
      attr_accessor :labels

      # @return [Array<EndpointProperties>] The endpoints exposed by this
      # container.
      attr_accessor :endpoints

      # @return [ResourceRequirements] This type describes the resource
      # requirements for a container or a service.
      attr_accessor :resources

      # @return [Array<ContainerVolume>] The volumes to be attached to the
      # container.
      attr_accessor :volume_refs

      # @return [ContainerInstanceView] Runtime information of a container
      # instance.
      attr_accessor :instance_view

      # @return [DiagnosticsRef] Reference to sinks in DiagnosticsDescription.
      attr_accessor :diagnostics


      #
      # Mapper for ContainerCodePackageProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ContainerCodePackageProperties',
          type: {
            name: 'Composite',
            class_name: 'ContainerCodePackageProperties',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              image: {
                client_side_validation: true,
                required: true,
                serialized_name: 'image',
                type: {
                  name: 'String'
                }
              },
              image_registry_credential: {
                client_side_validation: true,
                required: false,
                serialized_name: 'imageRegistryCredential',
                type: {
                  name: 'Composite',
                  class_name: 'ImageRegistryCredential'
                }
              },
              entrypoint: {
                client_side_validation: true,
                required: false,
                serialized_name: 'entrypoint',
                type: {
                  name: 'String'
                }
              },
              commands: {
                client_side_validation: true,
                required: false,
                serialized_name: 'commands',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              environment_variables: {
                client_side_validation: true,
                required: false,
                serialized_name: 'environmentVariables',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EnvironmentVariableElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EnvironmentVariable'
                      }
                  }
                }
              },
              settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'settings',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'SettingElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Setting'
                      }
                  }
                }
              },
              labels: {
                client_side_validation: true,
                required: false,
                serialized_name: 'labels',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ContainerLabelElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ContainerLabel'
                      }
                  }
                }
              },
              endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'endpoints',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EndpointPropertiesElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EndpointProperties'
                      }
                  }
                }
              },
              resources: {
                client_side_validation: true,
                required: true,
                serialized_name: 'resources',
                type: {
                  name: 'Composite',
                  class_name: 'ResourceRequirements'
                }
              },
              volume_refs: {
                client_side_validation: true,
                required: false,
                serialized_name: 'volumeRefs',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ContainerVolumeElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ContainerVolume'
                      }
                  }
                }
              },
              instance_view: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'instanceView',
                type: {
                  name: 'Composite',
                  class_name: 'ContainerInstanceView'
                }
              },
              diagnostics: {
                client_side_validation: true,
                required: false,
                serialized_name: 'diagnostics',
                type: {
                  name: 'Composite',
                  class_name: 'DiagnosticsRef'
                }
              }
            }
          }
        }
      end
    end
  end
end
