# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Represents the health state chunk of a deployed application, which
    # contains the node where the application is deployed, the aggregated
    # health state and any deployed service packages that respect the chunk
    # query description filters.
    #
    class DeployedApplicationHealthStateChunk < EntityHealthStateChunk

      include MsRestAzure

      # @return [String] The name of node where the application is deployed.
      attr_accessor :node_name

      # @return [DeployedServicePackageHealthStateChunkList] The list of
      # deployed service package health state chunks belonging to the deployed
      # application that respect the filters in the cluster health chunk query
      # description.
      attr_accessor :deployed_service_package_health_state_chunks


      #
      # Mapper for DeployedApplicationHealthStateChunk class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeployedApplicationHealthStateChunk',
          type: {
            name: 'Composite',
            class_name: 'DeployedApplicationHealthStateChunk',
            model_properties: {
              health_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'HealthState',
                type: {
                  name: 'String'
                }
              },
              node_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'NodeName',
                type: {
                  name: 'String'
                }
              },
              deployed_service_package_health_state_chunks: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DeployedServicePackageHealthStateChunks',
                type: {
                  name: 'Composite',
                  class_name: 'DeployedServicePackageHealthStateChunkList'
                }
              }
            }
          }
        }
      end
    end
  end
end
