# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Represents health evaluation for the partitions of a service, containing
    # health evaluations for each unhealthy partition that impacts current
    # aggregated health state. Can be returned when evaluating service health
    # and the aggregated health state is either Error or Warning.
    #
    class PartitionsHealthEvaluation < HealthEvaluation

      include MsRestAzure


      def initialize
        @Kind = "Partitions"
      end

      attr_accessor :Kind

      # @return [Integer] Maximum allowed percentage of unhealthy partitions
      # per service from the ServiceTypeHealthPolicy.
      attr_accessor :max_percent_unhealthy_partitions_per_service

      # @return [Integer] Total number of partitions of the service from the
      # health store.
      attr_accessor :total_count

      # @return [Array<HealthEvaluationWrapper>] List of unhealthy evaluations
      # that led to the aggregated health state. Includes all the unhealthy
      # PartitionHealthEvaluation that impacted the aggregated health.
      attr_accessor :unhealthy_evaluations


      #
      # Mapper for PartitionsHealthEvaluation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Partitions',
          type: {
            name: 'Composite',
            class_name: 'PartitionsHealthEvaluation',
            model_properties: {
              aggregated_health_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'AggregatedHealthState',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Description',
                type: {
                  name: 'String'
                }
              },
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              max_percent_unhealthy_partitions_per_service: {
                client_side_validation: true,
                required: false,
                serialized_name: 'MaxPercentUnhealthyPartitionsPerService',
                type: {
                  name: 'Number'
                }
              },
              total_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'TotalCount',
                type: {
                  name: 'Number'
                }
              },
              unhealthy_evaluations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UnhealthyEvaluations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'HealthEvaluationWrapperElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'HealthEvaluationWrapper'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
