# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_4_0_36
  module Models
    #
    # Statistics about setup or main entry point  of a code package deployed on
    # a Service Fabric node.
    #
    class CodePackageEntryPointStatistics

      include MsRestAzure

      # @return [String] The last exit code of the entry point.
      attr_accessor :last_exit_code

      # @return [DateTime] The last time (in UTC) when Service Fabric attempted
      # to run the entry point.
      attr_accessor :last_activation_time

      # @return [DateTime] The last time (in UTC) when the entry point finished
      # running.
      attr_accessor :last_exit_time

      # @return [DateTime] The last time (in UTC) when the entry point ran
      # successfully.
      attr_accessor :last_successful_activation_time

      # @return [DateTime] The last time (in UTC) when the entry point finished
      # running gracefully.
      attr_accessor :last_successful_exit_time

      # @return [String] Number of times the entry point has run.
      attr_accessor :activation_count

      # @return [String] Number of times the entry point failed to run.
      attr_accessor :activation_failure_count

      # @return [String] Number of times the entry point continuously failed to
      # run.
      attr_accessor :continuous_activation_failure_count

      # @return [String] Number of times the entry point finished running.
      attr_accessor :exit_count

      # @return [String] Number of times the entry point failed to exit
      # gracefully.
      attr_accessor :exit_failure_count

      # @return [String] Number of times the entry point continuously failed to
      # exit gracefully.
      attr_accessor :continuous_exit_failure_count


      #
      # Mapper for CodePackageEntryPointStatistics class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CodePackageEntryPointStatistics',
          type: {
            name: 'Composite',
            class_name: 'CodePackageEntryPointStatistics',
            model_properties: {
              last_exit_code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastExitCode',
                type: {
                  name: 'String'
                }
              },
              last_activation_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastActivationTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_exit_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastExitTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_successful_activation_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastSuccessfulActivationTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_successful_exit_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LastSuccessfulExitTime',
                type: {
                  name: 'DateTime'
                }
              },
              activation_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ActivationCount',
                type: {
                  name: 'String'
                }
              },
              activation_failure_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ActivationFailureCount',
                type: {
                  name: 'String'
                }
              },
              continuous_activation_failure_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ContinuousActivationFailureCount',
                type: {
                  name: 'String'
                }
              },
              exit_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ExitCount',
                type: {
                  name: 'String'
                }
              },
              exit_failure_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ExitFailureCount',
                type: {
                  name: 'String'
                }
              },
              continuous_exit_failure_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ContinuousExitFailureCount',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
