# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_5_0_36
  module Models
    #
    # This type describes a volume resource.
    #
    class VolumeResourceDescription

      include MsRestAzure

      # @return [String] Name of the Volume resource.
      attr_accessor :name

      # @return [String] User readable description of the volume.
      attr_accessor :description

      # @return [ResourceStatus] Status of the volume. Possible values include:
      # 'Unknown', 'Ready', 'Upgrading', 'Creating', 'Deleting', 'Failed'
      attr_accessor :status

      # @return [String] Gives additional information about the current status
      # of the volume.
      attr_accessor :status_details

      # @return [String] Provider of the volume. Default value: 'SFAzureFile' .
      attr_accessor :provider

      # @return [VolumeProviderParametersAzureFile] This type describes a
      # volume provided by an Azure Files file share.
      attr_accessor :azure_file_parameters


      #
      # Mapper for VolumeResourceDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VolumeResourceDescription',
          type: {
            name: 'Composite',
            class_name: 'VolumeResourceDescription',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.status',
                type: {
                  name: 'String'
                }
              },
              status_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.statusDetails',
                type: {
                  name: 'String'
                }
              },
              provider: {
                client_side_validation: true,
                required: true,
                is_constant: true,
                serialized_name: 'properties.provider',
                default_value: 'SFAzureFile',
                type: {
                  name: 'String'
                }
              },
              azure_file_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.azureFileParameters',
                type: {
                  name: 'Composite',
                  class_name: 'VolumeProviderParametersAzureFile'
                }
              }
            }
          }
        }
      end
    end
  end
end
