# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # This type describes a gateway resource.
    #
    class GatewayResourceDescription

      include MsRestAzure

      # @return [String] Name of the Gateway resource.
      attr_accessor :name

      # @return [String] User readable description of the gateway.
      attr_accessor :description

      # @return [NetworkRef] Network the gateway should listen on for requests.
      attr_accessor :source_network

      # @return [NetworkRef] Network that the Application is using.
      attr_accessor :destination_network

      # @return [Array<TcpConfig>] Configuration for tcp connectivity for this
      # gateway.
      attr_accessor :tcp

      # @return [Array<HttpConfig>] Configuration for http connectivity for
      # this gateway.
      attr_accessor :http

      # @return [ResourceStatus] Status of the resource. Possible values
      # include: 'Unknown', 'Ready', 'Upgrading', 'Creating', 'Deleting',
      # 'Failed'
      attr_accessor :status

      # @return [String] Gives additional information about the current status
      # of the gateway.
      attr_accessor :status_details

      # @return [String] IP address of the gateway. This is populated in the
      # response and is ignored for incoming requests.
      attr_accessor :ip_address


      #
      # Mapper for GatewayResourceDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'GatewayResourceDescription',
          type: {
            name: 'Composite',
            class_name: 'GatewayResourceDescription',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              source_network: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.sourceNetwork',
                type: {
                  name: 'Composite',
                  class_name: 'NetworkRef'
                }
              },
              destination_network: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.destinationNetwork',
                type: {
                  name: 'Composite',
                  class_name: 'NetworkRef'
                }
              },
              tcp: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tcp',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TcpConfigElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'TcpConfig'
                      }
                  }
                }
              },
              http: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.http',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'HttpConfigElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'HttpConfig'
                      }
                  }
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.status',
                type: {
                  name: 'String'
                }
              },
              status_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.statusDetails',
                type: {
                  name: 'String'
                }
              },
              ip_address: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.ipAddress',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
