# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Information about the ImageStore's resource usage
    #
    class ImageStoreInfo

      include MsRestAzure

      # @return [DiskInfo] disk capacity and available disk space on the node
      # where the ImageStore primary is placed.
      attr_accessor :disk_info

      # @return [UsageInfo] the ImageStore's file system usage for metadata.
      attr_accessor :used_by_metadata

      # @return [UsageInfo] The ImageStore's file system usage for staging
      # files that are being uploaded.
      attr_accessor :used_by_staging

      # @return [UsageInfo] the ImageStore's file system usage for copied
      # application and cluster packages. [Removing application and cluster
      # packages](https://docs.microsoft.com/en-us/rest/api/servicefabric/sfclient-api-deleteimagestorecontent)
      # will free up this space.
      attr_accessor :used_by_copy

      # @return [UsageInfo] the ImageStore's file system usage for registered
      # and cluster packages. [Unregistering
      # application](https://docs.microsoft.com/en-us/rest/api/servicefabric/sfclient-api-unprovisionapplicationtype)
      # and [cluster
      # packages](https://docs.microsoft.com/en-us/rest/api/servicefabric/sfclient-api-unprovisionapplicationtype)
      # will free up this space.
      attr_accessor :used_by_register


      #
      # Mapper for ImageStoreInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ImageStoreInfo',
          type: {
            name: 'Composite',
            class_name: 'ImageStoreInfo',
            model_properties: {
              disk_info: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DiskInfo',
                type: {
                  name: 'Composite',
                  class_name: 'DiskInfo'
                }
              },
              used_by_metadata: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UsedByMetadata',
                type: {
                  name: 'Composite',
                  class_name: 'UsageInfo'
                }
              },
              used_by_staging: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UsedByStaging',
                type: {
                  name: 'Composite',
                  class_name: 'UsageInfo'
                }
              },
              used_by_copy: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UsedByCopy',
                type: {
                  name: 'Composite',
                  class_name: 'UsageInfo'
                }
              },
              used_by_register: {
                client_side_validation: true,
                required: false,
                serialized_name: 'UsedByRegister',
                type: {
                  name: 'Composite',
                  class_name: 'UsageInfo'
                }
              }
            }
          }
        }
      end
    end
  end
end
