# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Describes a setting for the container. The setting file path can be
    # fetched from environment variable "Fabric_SettingPath". The path for
    # Windows container is "C:\\secrets". The path for Linux container is
    # "/var/secrets".
    #
    class Setting

      include MsRestAzure

      # @return [SettingType] The type of the setting being given in value.
      # Possible values include: 'ClearText', 'KeyVaultReference',
      # 'SecretValueReference'. Default value: 'ClearText' .
      attr_accessor :type

      # @return [String] The name of the setting.
      attr_accessor :name

      # @return [String] The value of the setting, will be processed based on
      # the type provided.
      attr_accessor :value


      #
      # Mapper for Setting class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Setting',
          type: {
            name: 'Composite',
            class_name: 'Setting',
            model_properties: {
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                default_value: 'ClearText',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              value: {
                client_side_validation: true,
                required: false,
                serialized_name: 'value',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
